#ifndef __NBHW_FPGA_H
#define __NBHW_FPGA_H

//#include <nbsw.h>
#define NBSW_TARGET_netbolt_arm
#include <linux/types.h>

extern void nbhw_fpga_lock_init(void);
extern void nbhw_fpga_lock(void);
extern void nbhw_fpga_unlock(void);

/* NBHW 8, 14, 17 */
extern void nbhw08_fpga_init(const char *compatible);
extern int nbhw08_fpga_get_irq(void);
extern void nbhw08_fpga_set_reg(u32 reg, u16 value);
extern u16 nbhw08_fpga_get_reg(u32 reg);

/* NBHW 12 */
extern void nbhw12_fpga_init(const char *compatible);
extern int nbhw12_fpga_get_irq(void);
extern void nbhw12_fpga_set_reg(u32 reg, u16 value);
extern u16 nbhw12_fpga_get_reg(u32 reg);

#ifdef NBSW_TARGET_netbox_ppc
#define FPGA_BASE_ADDRESS			0xF0000000
#elif defined(NBSW_TARGET_netbolt_arm)
#define FPGA_BASE_ADDRESS			0xFD000000
#else
#endif
#define FPGA_BASE_SIZE				131072

#define FPGA_IDENTIFICATION			0x00000000
#define FPGA_VERSION				0x00000002
#define FPGA_SCRATCH				0x00000004
#define FPGA_STATUS 				0x00000006
#define FPGA_OUTPUT1 				0x00000008 /* Only available on NBHW17 */
#define FPGA_INT_MASK_1				0x00000010
#define FPGA_INT_MASK_2				0x00000012
#define FPGA_INT_PENDING_1			0x00000014
#define FPGA_INT_PENDING_2			0x00000016
#define FPGA_INT_STATUS_1			0x00000018
#define FPGA_INT_STATUS_2			0x0000001a
#define FPGA_INT_ACK_1				0x00000018
#define FPGA_INT_ACK_2				0x0000001a
#define FPGA_LED    				0x00000020
#define FPGA_SERIAL_CTRL			0x00000024
#define FPGA_PCIE_RESET				0x00000030
#define FPGA_PCIE_POWER				0x00000032
#define FPGA_PCIE_SIM_CLOCK			0x00000034
#define FPGA_SIM_CTRL				0x00000040
#define FPGA_SIM_BUS_CTRL			0x00000042
#define FPGA_SMI_CTRL				0x00000042
#define FPGA_PSE_SSI_OUTPUT 		0x00000050
#define FPGA_PSE_SSI_INPUT  		0x00000060


#define FPGA_PCIE_SLOT_DIR_OFFS		0x0000
#define FPGA_PCIE_SLOT_CTRL_OFFS	0x0002
#define FPGA_PCIE_VCTL_OFFS			0x0010
#define FPGA_PCIE_VRDB_OFFS			0x0012
#define FPGA_PCIE_VRBFL_OFFS		0x0014
#define FPGA_PCIE_VRBW_OFFS			0x0016
#define FPGA_PCIE_VRIS_OFFS			0x0018
#define FPGA_PCIE_VTDB_OFFS			0x001a
#define FPGA_PCIE_VTBFL_OFFS		0x001c
#define FPGA_PCIE_VTBW_OFFS			0x001e
#define FPGA_PCIE_VTIS_OFFS			0x0020

#define FPGA_PCIE1_BASE				0x00000100
#define FPGA_PCIE1_SLOT_DIR			(FPGA_PCIE1_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE1_SLOT_CTRL		(FPGA_PCIE1_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)
#define FPGA_PCIE1_VCTL				(FPGA_PCIE1_BASE+FPGA_PCIE_VCTL_OFFS)
#define FPGA_PCIE1_VRDB				(FPGA_PCIE1_BASE+FPGA_PCIE_VRDB_OFFS)
#define FPGA_PCIE1_VRBFL			(FPGA_PCIE1_BASE+FPGA_PCIE_VRBFL_OFFS)
#define FPGA_PCIE1_VRBW				(FPGA_PCIE1_BASE+FPGA_PCIE_VRBW_OFFS)
#define FPGA_PCIE1_VRIS				(FPGA_PCIE1_BASE+FPGA_PCIE_VRIS_OFFS)
#define FPGA_PCIE1_VTDB				(FPGA_PCIE1_BASE+FPGA_PCIE_VTDB_OFFS)
#define FPGA_PCIE1_VTBFL			(FPGA_PCIE1_BASE+FPGA_PCIE_VTBFL_OFFS)
#define FPGA_PCIE1_VTBW				(FPGA_PCIE1_BASE+FPGA_PCIE_VTBW_OFFS)
#define FPGA_PCIE1_VTIS				(FPGA_PCIE1_BASE+FPGA_PCIE_VTIS_OFFS)

#define FPGA_PCIE2_BASE				0x00000200
#define FPGA_PCIE2_SLOT_DIR			(FPGA_PCIE2_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE2_SLOT_CTRL		(FPGA_PCIE2_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)
#define FPGA_PCIE2_VCTL				(FPGA_PCIE2_BASE+FPGA_PCIE_VCTL_OFFS)
#define FPGA_PCIE2_VRDB				(FPGA_PCIE2_BASE+FPGA_PCIE_VRDB_OFFS)
#define FPGA_PCIE2_VRBFL			(FPGA_PCIE2_BASE+FPGA_PCIE_VRBFL_OFFS)
#define FPGA_PCIE2_VRBW				(FPGA_PCIE2_BASE+FPGA_PCIE_VRBW_OFFS)
#define FPGA_PCIE2_VRIS				(FPGA_PCIE2_BASE+FPGA_PCIE_VRIS_OFFS)
#define FPGA_PCIE2_VTDB				(FPGA_PCIE2_BASE+FPGA_PCIE_VTDB_OFFS)
#define FPGA_PCIE2_VTBFL			(FPGA_PCIE2_BASE+FPGA_PCIE_VTBFL_OFFS)
#define FPGA_PCIE2_VTBW				(FPGA_PCIE2_BASE+FPGA_PCIE_VTBW_OFFS)
#define FPGA_PCIE2_VTIS				(FPGA_PCIE2_BASE+FPGA_PCIE_VTIS_OFFS)

#define FPGA_PCIE3_BASE				0x00000300
#define FPGA_PCIE3_SLOT_DIR			(FPGA_PCIE3_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE3_SLOT_CTRL		(FPGA_PCIE3_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)

#define FPGA_PCIE4_BASE				0x00000400
#define FPGA_PCIE4_SLOT_DIR			(FPGA_PCIE4_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE4_SLOT_CTRL		(FPGA_PCIE4_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)

#define FPGA_PCIE5_BASE				0x00000500
#define FPGA_PCIE5_SLOT_DIR 		(FPGA_PCIE5_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE5_SLOT_CTRL		(FPGA_PCIE5_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)

#define FPGA_PCIE6_BASE				0x00000600
#define FPGA_PCIE6_SLOT_DIR			(FPGA_PCIE6_BASE+FPGA_PCIE_SLOT_DIR_OFFS)
#define FPGA_PCIE6_SLOT_CTRL		(FPGA_PCIE6_BASE+FPGA_PCIE_SLOT_CTRL_OFFS)

#endif /* __NBHW_FPGA_H */


